import { Injectable } from '@angular/core';
import { environment } from '../../environments/environment';
import {HttpClient, HttpHeaders, HttpParams} from '@angular/common/http';
{$ import_statement_list|safe $}

@Injectable({
  providedIn: 'root'
})
export class {$ class_name|safe $}Service {

  {$ property_decl|safe $}

  constructor(private http: HttpClient{% if constructor_param %},{$ constructor_param|safe $}{% endif %}) {
    {$ constructor_body|safe $}
  }

  httpOptions = {

    headers: new HttpHeaders({
      'Content-Type': 'application/json'
    })
  };

  endpoint: string = environment.rootApi + '{$ api_endpoint|safe $}';

  call({$ call_param|safe $}){
    let httpParams = new HttpParams();
    {% if enable_auth %}
    let key_token = 'token';
    let googleToken = localStorage.getItem(key_token);
    httpParams = httpParams.append(key_token, googleToken);
    {% endif %}
    {% if call_param %}
    Object.keys(param).forEach(function (key) {
         httpParams = httpParams.append(key, param[key]);
    });
    {% endif %}
    this.httpOptions['params'] = httpParams;
    return this.http.get(this.endpoint, this.httpOptions).toPromise();
  }
}
